#include "niceshaper.h"
#include "ns_container.h"
#include "ns_instance.h"

char conffile[MAX_PATH];
char classfile[MAX_PATH];
char usersfile[MAX_PATH];
char pidfile[MAX_PATH] = "/var/run/niceshaper.pid";
char statsfile[MAX_PATH] = "/tmp/niceshaper.stats";
char statsflag[MAX_PATH] = "/tmp/niceshaper.stats.flag";

char section[SHORT_BUF];
char ipt_mychain[15];
char ipt_myparent[15];

unsigned int working = 0;
unsigned int section_htb_ceil = 0;
unsigned int section_shape = 0;
unsigned int section_interactive_sum = 0;
unsigned int section_id = 0;
unsigned int section_max_permills = 1000;

unittype statsunit = kbps;
char chstatsunit[8] = "kB/s";
char markifaces[LONG_BUF];
bool overload;
bool debug_ipt = false;
bool debug_tc = false;
bool i_am_parent;

class nsattrib *ns;
class instanceattrib *parent_instance = NULL;

std::vector < instanceattrib * >instance;

int main(int argc, char *argv[])
{
  char sessions[LONG_BUF] = "", buf[LONG_BUF] = "", option[32] = "";
  char statsfileowner[SHORT_BUF] = "root";
  char statsfilegroup[SHORT_BUF] = "root";
  char statsfilemode[SHORT_BUF] = "644";
  char statspath[MAX_PATH] = "";  
  bool dump_stats = false;

  vector < char * > fpv_sf;
  vector < char * >::iterator fpv_i, fpv_begin_i, fpv_end_i, fpv_tmp_i;

  struct timeval now, past;
  int fd;
  FILE *fp;
  int n;

  strcpy(conffile, "/etc/niceshaper0.6/config");
  strcpy(classfile, "/etc/niceshaper0.6/class");
  strcpy(usersfile, "/etc/niceshaper0.6/users");

  run(argc, argv);

  if (fork()) {
    while (access(pidfile, 0)) usleep(100000);
    usleep(1000000);
    exit(0);
  }

  fp = fopen(conffile, "r");
  fseek(fp, 0, SEEK_SET);
  if ( conv_to_fpv ( fpv_sf, fp , NULL ) == -1 ) {
    fclose(fp);
    return -1;
  }
  fclose(fp);
				  

  fpv_section_i(fpv_begin_i, fpv_end_i,fpv_sf,"global");
  fpv_i=fpv_begin_i;
  while ( fpv_i != fpv_end_i ) {
    strcpy ( buf , *fpv_i );
    fpv_i++;
	strcpy(option, awk(buf, 1));
    if (!strcmp(option, "stats")) {
  	  if (strstr(buf, "unit")) {
  		statsunit = getunit(awk(strstr(buf, "unit"), 2));
		strcpy(chstatsunit, awk(strstr(buf, "unit"), 2));
  	  }
  	  if (strstr(buf, "file")) {
		strcpy(statspath, awk(strstr(buf, "file"), 2));
		if (!strcmp(statspath, "none") || !strcmp(statspath, "false") || !strlen(statspath)) {
	  	  dump_stats = false;
		}
		else {
		  dump_stats = true;
		}
	  }
  	  if (strstr(buf, "owner")) {
		strcpy(statsfileowner, awk(strstr(buf, "owner"), 2));
  	  }
  	  if (strstr(buf, "group")) {
		strcpy(statsfilegroup, awk(strstr(buf, "group"), 2));
  	  }
  	  if (strstr(buf, "mode")) {
		strcpy(statsfilemode, awk(strstr(buf, "mode"), 2));
  	  }
    } 
	else if (!strcmp(option, "run")) {
      n = 2;
    	while (strlen(awk(buf, n))) {
  		  strcat(sessions, awk(buf, n));
		  strcat(sessions, " ");
		  n++;
      }	
    } 
	else if (!strcmp(option, "support")) {
      if (!strcmp(awk(buf, 2), "mark")) {
        if (!strcmp(awk(buf, 3), "on")) {
          strcpy(markifaces, "");
	      n = 4;
          while (strlen(awk(buf, n))) {
	        strcat(markifaces, awk(buf, n));
	        strcat(markifaces, " ");
	        n++;
	      }
  	    }
      }
    }															
  }

  system_ipt ("for n in `iptables -t mangle -L PREROUTING -nv --line-numbers | grep ns_ | awk '{print $1}' | sort -r`; do iptables -t mangle -D PREROUTING $n ; done");
  system_ipt ("for n in `iptables -t mangle -L POSTROUTING -nv --line-numbers | grep ns_ | awk '{print $1}' | sort -r`; do iptables -t mangle -D POSTROUTING $n ; done");
  system_ipt ("for n in `iptables -t mangle -L INPUT -nv --line-numbers | grep ns_ | awk '{print $1}' | sort -r`; do iptables -t mangle -D INPUT $n ; done");
  system_ipt ("for n in `iptables -t mangle -L OUTPUT -nv --line-numbers | grep ns_ | awk '{print $1}' | sort -r`; do iptables -t mangle -D OUTPUT $n ; done");
  system_ipt ("for n in `iptables -t mangle -L FORWARD -nv --line-numbers | grep ns_ | awk '{print $1}' | sort -r`; do iptables -t mangle -D FORWARD $n ; done");
  system_ipt ("for n in `iptables -t mangle -L -nv | grep 'Chain ns_' | awk '{print $2}'`; do iptables -t mangle -F $n ; iptables -t mangle -X $n;  done");

  n = 1;
  char tag[LONG_BUF];
  char dev[MAX_IFACE];
  char buf2[LONG_BUF];    
  
  while (strlen(awk(sessions, n))) {
    strcpy(tag, awk(sessions, n));  
    fpv_section_i( fpv_begin_i, fpv_end_i, fpv_sf, tag );
	fpv_i = fpv_begin_i;
	while ( fpv_i != fpv_end_i ) {
	  strcpy ( buf , *fpv_i );
	  fpv_i ++;
      strcpy(option, awk(buf, 1));
      if (!strcmp(option, "iface")) {
        strcpy( buf2, "" );
		strcpy( dev , awk(buf, 2) );
		if ( valid_dev (dev) == -1 ) {
		  printf ( "\tNot proper dev: %s\n",buf );
		  creat(pidfile, 0660);
		  usleep(200000);
		  unlink(pidfile);
		  exit(0);
		}
		sprintf(buf2, "tc qdisc del root dev %s 2> /dev/null > /dev/null", dev);
		system_tc(buf2);
		sprintf(buf2, "tc qdisc add dev %s root handle 1: htb default 1", dev);
		system_tc(buf2);
		sprintf(buf2, "tc class add dev %s parent 1: classid 1:1 htb rate 100mbit quantum 8738", dev);
		system_tc(buf2);
      } 
	}
	n++;
  }

  n = 1;
  signal(SIGTERM, signalterm);
  while (strlen(awk(sessions, n))) {
    strcpy(section, awk(sessions, n));
    section_id = 10 + n;
    instance.push_back(new instanceattrib());
    if (i_am_parent) {
      if (instance[instance.size() - 1]->get_init_status() == -1) {
		creat(pidfile, 0660);
  		usleep(200000);
  		unlink(pidfile);
    	strcpy(section, "global");	
		signalterm(SIGTERM);	  
      }
    } 
    else {
      parent_instance = instance[instance.size() - 1];
      sprintf(ipt_mychain, "ns_%s", section);
      break;
    }
    n++;
  }
  
  if (i_am_parent) {
    sprintf(buf, "%d", getpid());
    fd = creat(pidfile, 0660);
    write(fd, buf, strlen(buf));
    close(fd);
    strcpy(section, "global");
    printf("\n");
    if ( dump_stats ) {
      unlink(statspath);
      fd = creat(statspath, O_WRONLY);
      sprintf(buf, "chown %s:%s %s && chmod %s %s &", statsfileowner, statsfilegroup, statspath, statsfilemode, statspath);
      system(buf);
      close(fd);      
    }
    while (true) {
      for (unsigned int n = 0; n < instance.size(); n++) {
		instance[n]->sync();
		instance[n]->get_result();
		if (!access(statsflag, 0)) {
          unlink(statsfile);
		  fd = creat(statsfile, 0660);
		  for (unsigned int n = 0; n < instance.size(); n++) instance[n]->dump_stats(fd);
		  close(fd);
		  unlink(statsflag);
		}
		if ( dump_stats ) {
		  fd = open(statspath, O_RDWR | O_TRUNC);
		  for (unsigned int n = 0; n < instance.size(); n++) instance[n]->dump_stats(fd);
		  strcpy(buf, "                                Powered by NiceShaper\n");
		  write(fd, buf, strlen(buf));
		  strcpy(buf, "                       http://niceshaper.jedwabny.net\n");
		  write(fd, buf, strlen(buf));
		  close(fd);
		}
      }
    }
  } 
  else {
    unsigned long int cycle;
    ns = new nsattrib();
    if (ns->init() == -1) {
      printf("\tNiceShaper: CAN NOT start %s....\n", section);
      parent_instance->send_init_status_error();
      usleep(1000000);
    } 
    else {
      printf("\tNiceShaper: Starting %s....\n", section);
      parent_instance->send_init_status_ok();
    }
    gettimeofday(&past, NULL);
    n = 0;
    while (true) {
      usleep (100000);
      gettimeofday(&now, NULL);
      cycle = (now.tv_sec - past.tv_sec)*10 + (now.tv_usec - past.tv_usec)/100000;
      if ( cycle >= ns->get_reload() ) {
		ns->judge();
        parent_instance->sync();
        parent_instance->send_result(ns);
        gettimeofday(&past, NULL);        
      }
      else {
        parent_instance->sync();
        parent_instance->send_continue();
      }
    } 
  }
  return 0;
}
void run(int argc, char *argv[])
{
  int dpid, fd;
  char buf[LONG_BUF];
  struct timeval now;

  if (argc == 1) {
    help();
    exit(0);
  }

  for (int n = 2; n < argc; n++) {
    if (std::string(argv[n]) == "--confdir") {
      sprintf(conffile, "%s/config", argv[n + 1]);
      sprintf(classfile, "%s/class", argv[n + 1]);
      sprintf(usersfile, "%s/users", argv[n + 1]);
    }
  }
  for (int n = 2; n < argc; n++) {
    if (std::string(argv[n]) == "--conffile")
      strcpy(conffile, argv[n + 1]);
    if (std::string(argv[n]) == "--classfile")
      strcpy(classfile, argv[n + 1]);
    if (std::string(argv[n]) == "--usersfile")
      strcpy(usersfile, argv[n + 1]);
  }
  if (std::string(argv[1]) == "convert") {
    if (access(usersfile, 0)) {
      printf("\n\tfile %s does not exist\nquit..\n\n", usersfile);
      exit(0);
    }
    if (!access(classfile, 0)) {
      gettimeofday(&now, NULL);
      sprintf(buf, "%s.%lu", classfile, now.tv_sec);
      printf("\n\tfile %s already exist,\nit will rename to:'%s'\n\n",
	     classfile, buf);
      rename(classfile, buf);
    }
    convert_usersfile();
    exit(0);
  } else if ((std::string(argv[1]) == "stop")
	     || (std::string(argv[1]) == "restart")) {
    if (access(pidfile, 0)) {
      printf
	  ("\n\tNiceShaper is not running...( there is not /var/run/niceshaper.pid file)\n\n");
      exit(0);
    }
    fd = open(pidfile, 0660);
    dpid = read(fd, buf, 8);
    buf[dpid] = '\0';
    dpid = atoi(buf);
    close(fd);
    kill(dpid, SIGTERM);
    printf("\n\twaiting...");
    while (!access(pidfile, 0))
      usleep(100000);
    printf("\n\tdone!\n\n");
    if (!strcmp(argv[1], "stop"))
      exit(0);
  } else if (std::string(argv[1]) == "stats") {
    char buf[10];
    int fd;
    if (access(pidfile, 0)) {
      printf
	  ("\n\tNiceShaper is not running...( there is not /var/run/niceshaper.pid file)\n\n");
      exit(0);
    }
    creat(statsflag, 0660);
    while (!access(statsflag, 0))
      usleep(100000);
    while (access(statsfile, 0))
      usleep(100000);;
    fd = open(statsfile, 0660);
    while (read(fd, buf, 1))
      printf("%c", buf[0]);
    close(fd);
    exit(0);
  }
  if ((std::string(argv[1]) != "start")
      && (std::string(argv[1]) != "restart")) {
    help();
    exit(0);
  }
  if (!access(pidfile, 0)) {
    printf
	("\n\tNiceShaper alredy running...( there is /var/run/niceshaper.pid file) \n\n");
    exit(0);
  }
  if (access(classfile, R_OK)) {
    printf("\n\tcan't read %s file\nquit...\n\n", classfile);
    exit(0);
  }
  if (access(conffile, R_OK)) {
    printf("\n\tcan't read %s file\nquit...\n\n", conffile);
    exit(0);
  }
  printf("\n\tNiceshaper version:%s\n\thttp://niceshaper.jedwabny.net\n\n",
	 version);
}
void signalterm(int sig)
{
  signal(SIGTERM, signalterm);

  if (i_am_parent) {
    for (unsigned int n = 0; n < instance.size(); n++) {
      instance[n]->kill_child();
      delete instance[n];
    }
    instance.clear();
    unlink(pidfile);
    printf("\n\tQuit %s instance...\n", section);
    exit(0);
  } 
  else {
    delete ns;
    delete parent_instance;
    printf("\n\tQuit %s instance...\n", section);
    exit(0);
  }
}
int dotobit(char mask[])
{
  unsigned long addr;
  int n, bit;

  addr = ntohl(inet_addr(mask));
  for (n = 0, bit = 0; n < 32; n++)
    bit += (addr >> n) & 1;
  return bit;
}

bool bitodot(char mask[], int arg)
{
  struct in_addr netwrk;
  int n, m;

  if (arg < 0 || arg > 32)
    return false;
  for (m = 0, n = 0; n < arg; n++)
    m += 1 << (31 - n);
  netwrk.s_addr = htonl(m);
  strcpy(mask, inet_ntoa(netwrk));
  mask[strlen(mask)] = '\0';
  return true;
}

enum unittype getunit(char arg[])
{
  if (strstr(arg, "kbit")) return kbit;
  else if (strstr(arg, "mbit")) return mbit;
  else if (strstr(arg, "bit")) return bit;

  else if (strstr(arg, "kB")) return kbps;
  else if (strstr(arg, "mB")) return mbps;
  else if (strstr(arg, "B")) return bps;

  else if (strstr(arg, "kbps")) return kbit;
  else if (strstr(arg, "mbps")) return mbit;
  else if (strstr(arg, "bps")) return bit;

  else if (strstr(arg, "kBps")) return kbps;
  else if (strstr(arg, "mBps")) return mbps;
  else if (strstr(arg, "Bps")) return bps;

  else if (strstr(arg, "kb/s")) return kbit;
  else if (strstr(arg, "mb/s")) return mbit;
  else if (strstr(arg, "b/s")) return bit;

  else if (strstr(arg, "kB/s")) return kbps;
  else if (strstr(arg, "mB/s")) return mbps;
  else if (strstr(arg, "B/s")) return bps;

  else return bit;
}

long int unitconvert(char arg[], unittype resunit)
{
  return ((atol(arg) * (long int) getunit(arg)) / (long int) resunit);
}
long int unitconvert(long int arg, unittype resunit)
{
  return (arg / (long int) resunit);
}

int gen_ipt_filter (char result_buf[], char src_buf[])
{
  char addr[SHORT_IP_ADDR];
  char mask[SHORT_IP_ADDR];

  if (strstr(src_buf, "proto")) {
    strcat(result_buf, " -p ");
    strcat(result_buf, awk(strstr(src_buf, "proto"), 2));
    strcat(result_buf, " ");
  }
  if (strstr(src_buf, "srcip")) {
    if (split(addr, mask, awk(strstr(src_buf, "srcip"), 2)) == -1) return -1;
    strcat(result_buf, " -s ");
    strcat(result_buf, addr);
    strcat(result_buf, "/");
    strcat(result_buf, mask);
  }
  if (strstr(src_buf, "dstip")) {
    if (split(addr, mask, awk(strstr(src_buf, "dstip"), 2)) == -1) return -1;
    strcat(result_buf, " -d ");
    strcat(result_buf, addr);
    strcat(result_buf, "/");
    strcat(result_buf, mask);
  }
  if (strstr(src_buf, "srcport")) {
    strcat(result_buf, " --sport ");
    strcat(result_buf, awk(strstr(src_buf, "srcport"), 2));
    strcat(result_buf, " ");
  }
  if (strstr(src_buf, "dstport")) {
   strcat(result_buf, " --dport ");
   strcat(result_buf, awk(strstr(src_buf, "dstport"), 2));
   strcat(result_buf, " ");
  }
							
  if (strstr(src_buf, "state")) {
    if (!strcmp(awk(strstr(src_buf, "state"), 2), "new")) strcat(result_buf, " -m state --state new ");
    else if (!strcmp(awk(strstr(src_buf, "state"), 2), "established")) strcat(result_buf, " -m state --state established ");
    else if (!strcmp(awk(strstr(src_buf, "state"), 2), "related")) strcat(result_buf, " -m state --state related ");
    else if (!strcmp(awk(strstr(src_buf, "state"), 2), "invalid")) strcat(result_buf, " -m state --state invalid ");
    else if (!strcmp(awk(strstr(src_buf, "state"), 2), "untracked")) strcat(result_buf, " -m state --state untracked ");
    else { printf("\n%s: invalid state: %s\n", section, src_buf); return -1; }
  }
  else if (strstr(src_buf, "tos")) {
   strcat(result_buf, " -m tos --tos ");
   strcat(result_buf, awk(strstr(src_buf, "tos"), 2));
   strcat(result_buf, " ");
  }
  else if (strstr(src_buf, "ttl-lower")) {
    strcat(result_buf, " -m ttl --ttl-lt ");
    strcat(result_buf, awk(strstr(src_buf, "ttl-lower"), 2));
    strcat(result_buf, " ");
  }
  else if (strstr(src_buf, "ttl-greater")) {
    strcat(result_buf, " -m ttl --ttl-gt ");
    strcat(result_buf, awk(strstr(src_buf, "ttl-greater"), 2));
    strcat(result_buf, " ");
  }
  else if (strstr(src_buf, "ttl")) {
    strcat(result_buf, " -m ttl --ttl ");
    strcat(result_buf, awk(strstr(src_buf, "ttl"), 2));
    strcat(result_buf, " ");
  }    
  else if (strstr(src_buf, "mark")) {
    strcat(result_buf, " -m mark --mark ");
    strcat(result_buf, awk(strstr(src_buf, "mark"), 2));
    strcat(result_buf, " ");
  }	
  return 1;	   												
}

char *awk(char param[], unsigned int word)
{
  unsigned int n, aku;
  char buf[128];
  static char result[128];

  aku = 0;
  strcpy(buf, "");
  strcpy(result, "");
  for (n = 0; n + 1 < strlen(param); n++) {
    if ((param[n] == 32 || param[n] == 9)
	&& (param[n + 1] != 32 && param[n + 1] != 9))
      aku++;
    if (n == 0 && param[0] != 32 && param[0] != 9)
      aku++;
    if (aku == word) {
      if (n == 0 && param[0] != 32 && param[0] != 9)
	strcpy(buf, param);
      else
	strcpy(buf, &(param)[n + 1]);
      n = strlen(param);
    }
  }
  for (n = 0; n < strlen(buf); n++) {
    if (buf[n] == 32 || buf[n] == 9 || buf[n] == 10) {
      buf[n] = '\0';
      n = strlen(buf);
    }
  }
  strcpy(result, buf);
  if (strlen(result))
    return result;
  else
    return "";
  return result;
}

bool getip(char netaddr[], char dev[])
{
  char buf[256];
  FILE *pp;

  strcpy(netaddr, "");
  strcpy(buf, "");
  sprintf(buf, "ip addr show dev %s", dev);
  pp = popen(buf, "r");
  while (fgets(buf, LONG_BUF, pp)) {
    if (!strcmp(awk(buf, 1), "inet")) {
      strcpy(netaddr, awk(buf, 2));
      pclose(pp);
      return true;
    }
  }
  pclose(pp);
  return false;
}
void iptohostname(char hostname[], char ipaddr[])
{
  uint32_t addr;
  struct hostent *hp;
  strcpy(hostname, "");
  addr = inet_addr(ipaddr);
  hp = gethostbyaddr((char *) &addr, sizeof(addr), AF_INET);
  if (hp == NULL)
    strcpy(hostname, ipaddr);
  else
    strcpy(hostname, hp->h_name);
}

int split(char ipaddr[], char ipmask[], char buf[])
{
  strcpy(ipaddr, "");
  strcpy(ipmask, "");

  strncpy(ipaddr, buf, strcspn(buf, "/"));
  ipaddr[strcspn(buf, "/")] = '\0';
  trim(ipaddr);
  if (!valid_ip(ipaddr))
    return -1;
  if (!strstr(buf, "/"))
    strcpy(ipmask, "255.255.255.255");
  else
    strcpy(ipmask, &(buf[strcspn(buf, "/") + 1]));
  trim(ipmask);
  if (!valid_ip(ipmask)) {
    if (strlen(ipmask) == 0)
      strcpy(ipmask, "255.255.255.255");
    else if (atoi(ipmask) >= 0 && atoi(ipmask) <= 32)
      bitodot(ipmask, atoi(ipmask));
    else
      return -1;

  }
  return 1;
}

unsigned int compute_quantum ( unsigned int rate ) {
  unsigned int quantum = rate / 8 / 1500;
  if (!quantum) quantum = 1;
  return quantum;
}

int valid_dev(char dev[])
{
  int i;
  bool dot = false;

  if ((dev[0] == 101 && dev[1] == 116 && dev[2] == 104)
      || (dev[0] == 112 && dev[1] == 112 && dev[2] == 112)
      || (dev[0] == 105 && dev[1] == 109 && dev[2] == 113)
      || (dev[0] == 97 && dev[1] == 116 && dev[2] == 104)) {
    i = 3;			// eth ppp imq ath
  } 
  else if (dev[0] == 98 && dev[1] == 114) {
    i = 2;			// br
  } 
  else if (dev[0] == 119 && dev[1] == 108 && dev[2] == 97 && dev[3] == 110) {
    i = 4;			// wlan
  } 
  else return -1;
  if (dev[i] < 48 || dev[i] > 57) return -1;
  i++; 
//  if (dev[n] != 0 && dev[n] != 9 && dev[n] != 10 && dev[n] != 32 && (dev[n] < 48 || dev[n] > 57)) return false;
//  return true;
  
  while (dev[i] != 0 && dev[i] != 9 && dev[i] != 10 && dev[i] != 32) {
    if ( dev[i] == 46 ) {
      if ( dot == true ) return -1;
      else dot = true;
    }
    else if ( (dev[i] < 48 || dev[i] > 57) ) {
      return -1; 
    }  
    i++;
    if ( i == MAX_IFACE ) return -1;
  }
  return true;
  
}

bool valid_ip(char ipaddr[])
{
  struct in_addr inaddr;
  if (!inet_aton(ipaddr, &inaddr)) return false;
  if (strcmp(ipaddr, inet_ntoa(inaddr))) return false;
  return true;
}

bool valid_port(int tcpport)
{
  if (tcpport >= 1 && tcpport <= 65536)
    return true;
  else
    return false;
}

bool valid_whiteline(char buf[])
{
  if (!strlen(buf))
    return true;
  else
    return false;
}

bool solid_ipmask(char ipmask[])
{
  unsigned long addr;

  if (!valid_ip(ipmask))
    return false;
  addr = htonl(inet_addr(ipmask));
  for (int n = 1; n < 32; n++)
    if (((addr >> n) & 1) == 0 && ((addr >> n - 1) & 1) == 1)
      return false;
  return true;
}

int trim(char buf[])
{
  int dl;

  dl = strlen(buf);
  for (int n = 0; n < dl; n++) {
    if (buf[n] == 9)
      buf[n] = 32;
    else if (buf[n] == 35)
      buf[n] = '\0';
    else if (buf[n] == 10)
      buf[n] = '\0';
  }
  while (buf[0] == 32) {
    dl = strlen(buf);
    for (int m = 0; m < (dl - 1); m++) {
      buf[m] = buf[m + 1];
    }
    buf[dl - 1] = '\0';
  }
  dl = strlen(buf) - 1;
  for (int n = dl; n >= 0; n--) {
    if (buf[n] == 32)
      buf[n] = '\0';
    else
      break;
  }
  dl = strlen(buf);
  for (int n = 0; n < dl; n++) {
    if (buf[n] == 32) {
      while (buf[n + 1] == 32) {
	for (int m = n; m < dl; m++) {
	  buf[m] = buf[m + 1];
	}
      }
    }
    if ((buf[n] >= 97) || (buf[n] <= 122))
      continue;
    else if ((buf[n] >= 65) || (buf[n] <= 90))
      continue;
    else if ((buf[n] >= 48) || (buf[n] <= 57))
      continue;
    else if ((buf[n] == 43) || (buf[n] == 45))
      continue;
    else if ((buf[n] == 60) || (buf[n] == 62) || (buf[n] == 46)
	     || (buf[n] == 47))
      continue;
    else {
      printf("\tforbidden char (%c):%s\n", buf[n], buf);
      return -1;
    }
  }
  return 0;
}

void convert_usersfile()
{
  int fd, n;
  char buf[LONG_BUF], option[35], userline[LONG_BUF], hostname[LONG_BUF],
      sections_modes[LONG_BUF] = "";
  char ip[16], dev[MAX_IFACE], section_start[32] = "", section_end[32] =
      "";
  char question[1];
  bool resolve;
  FILE *fp;

  printf("\tresolve hostname {y/n/q}\n");
  scanf("%s", question);
  if (!strcmp(question, "y")) {
    resolve = true;
    printf("\tusing hostname for class names\n");
  } else if (!strcmp(question, "n")) {
    resolve = false;
    printf("\tusing IP address for class name\n");
  } else {
    exit(0);
  }

  fp = fopen(conffile, "r");
  while (fgets(buf, LONG_BUF, fp)) {
    trim(buf);
    strcpy(option, awk(buf, 1));
    if (!strlen(option))
      continue;
    if (strstr(option, "<") && strstr(option, ">") && !strstr(option, "/")
	&& !strstr(option, "global")) {
      strcpy(section_start, option);
      strcpy(section, &(strstr(option, "<"))[1]);
      section[strcspn(option, ">") - 1] = '\0';
      sprintf(section_start, "<%s>", section);
      sprintf(section_end, "</%s>", section);
      strcat(sections_modes, section);
      bool mode_ok = false;
      while (fgets(buf, LONG_BUF, fp)) {
	trim(buf);
	strcpy(option, awk(buf, 1));
	if (!strlen(option))
	  continue;
	if (!strcmp(option, "mode")) {
	  if (!strcmp(awk(buf, 2), "download")) {
	    strcat(sections_modes, " dstip ");
	    mode_ok = true;
	  } else if (!strcmp(awk(buf, 2), "upload")) {
	    strcat(sections_modes, " srcip ");
	    mode_ok = true;
	  } else {
	    printf("\tbad mode in: %s \ncheck your config file\n", buf);
	    fclose(fp);
	    exit(0);
	  }
	} else if (!strcmp(option, section_end)) {
	  if (mode_ok)
	    break;
	  else {
	    printf("\tNo mode defined for %s sections\n", section);
	    fclose(fp);
	    exit(0);
	  }
	} else if (strstr(option, "<") && strstr(option, ">")) {
	  printf
	      ("\tsection %s is not properly closed\ncheck your config file\n", section);
	  fclose(fp);
	  exit(0);
	}
      }
    }
  }
  fclose(fp);

  n = 0;
  fd = creat(classfile, 0660);
  fp = fopen(usersfile, "r");
  while (fgets(userline, LONG_BUF, fp)) {
    strcpy(ip, awk(userline, 1));
    if (valid_ip(ip)) {
      if (resolve)
	iptohostname(hostname, ip);
      else
	strcpy(hostname, ip);
      sprintf(buf, "############### %s\n", hostname);
      write(fd, buf, strlen(buf));
      for (int i = 2; strlen(awk(userline, i)); i++) {
	strcpy(option, awk(userline, i));
	if (!strcmp(option, "section")) {
	  strcpy(section, awk(userline, i + 1));
	  strcpy(dev, awk(userline, i + 2));
	  sprintf(buf, "\nclass %s %s %s\n", section, dev, hostname);
	  write(fd, buf, strlen(buf));
	  if (!strstr(sections_modes, section)) {
	    printf("\nthere isn't configure %s section\n", section);
	    close(fd);
	    fclose(fp);
	    exit(0);
	  }
	  sprintf(buf, "    match %s %s\n",
		  awk(strstr(sections_modes, section), 2), hostname);
	  write(fd, buf, strlen(buf));
	} else if (!strcmp(option, "low")) {
	  sprintf(buf, "    low %s\n", awk(userline, i + 1));
	  write(fd, buf, strlen(buf));
	} else if (!strcmp(option, "ceil")) {
	  sprintf(buf, "    ceil %s\n", awk(userline, i + 1));
	  write(fd, buf, strlen(buf));
	} else if (!strcmp(option, "rate")) {
	  sprintf(buf, "    rate %s\n", awk(userline, i + 1));
	  write(fd, buf, strlen(buf));
	}
      }
      sprintf(buf, "\n");
      write(fd, buf, strlen(buf));

    } 
    else {
      printf("\t%s is not valid ip addr\n", ip);
      close(fd);
      fclose(fp);
      exit(0);
    }
  }
  close(fd);
  fclose(fp);
}

int fpv_section_i ( vector < char * >::iterator &fpv_begin_i, vector < char * >::iterator &fpv_end_i, vector < char * > &fpv, char section[] )
{
  char section_begin[LONG_BUF]="";
  char section_end[LONG_BUF]="";
  vector < char * >::iterator fpv_i;
  
  sprintf(section_begin, "<%s>", section);
  sprintf(section_end, "</%s>", section);
  fpv_i = fpv.begin();  

  while ( fpv_i != fpv.end() ) {
	if ( !strcmp ( *fpv_i , section_begin )) fpv_begin_i = fpv_i;
	else if ( !strcmp ( *fpv_i , section_end )) fpv_end_i = fpv_i;
	fpv_i ++;
  }
  return 1;
}

int conv_to_fpv ( vector < char * > &fpv, FILE * fp , char section[])
{
  int cbuf;
  int buf_counter = 0;    
  bool state_store = true;
  bool state_in_section = false;
  char * buf = new char [LONG_BUF];
  char section_begin [LONG_BUF] = "";
  char section_end [LONG_BUF] = "";

  sprintf(section_begin, "<%s>", section);  
  sprintf(section_end, "</%s>", section);  

  while ((cbuf = fgetc(fp)) != -1 ) {
  if ( cbuf == 35 ) state_store = false;
	if ( cbuf == 59 ) cbuf = 10;
	if ( cbuf == 10 ) state_store = true;
	if ( state_store ) {
	  buf[buf_counter]=cbuf;
	  buf_counter++;
	  if ( buf_counter == LONG_BUF-1 ) {
		printf("\t%s: Too long config line\n", section);
		fclose(fp);
		return -1;
	  }
	}
	if ( cbuf == 10 ) {
	  buf[buf_counter]=0;
	  if (trim(buf) == -1) {
	  	fclose(fp);
	  	return -1;
	  }
	if (!valid_whiteline(buf)) {
	  if ( section != NULL ) {
		if ( !strcmp ( buf , section_begin )) {
		  state_in_section = true;
		  fpv.push_back(buf);		  
		  buf = new char [LONG_BUF];		  
		}  
		else if ( !strcmp ( buf , section_end )) {
		  state_in_section = false;
	  	  fpv.push_back(buf);
		  buf = new char [LONG_BUF];		  
		}  
		else if ( state_in_section ) {
	  	  fpv.push_back(buf);
		  buf = new char [LONG_BUF];		  
		}
	  }
	  else {
		fpv.push_back(buf);
		buf = new char [LONG_BUF];		
	  }
	}
	buf_counter=0;
	state_store = true;
	}
  }
  return 0;
}

void system_ipt(char command[])
{
  if (debug_ipt) {
    printf("%s:%s\n", section, command);
  }
  system(command);
}

void system_tc(char command[])
{
  if (debug_tc) {
    printf("%s:%s\n", section, command);
  }
  system(command);
}

long int power( int val , int inc )
{
  long int result = 1;
  for ( int n = 1; n <= inc ; n++ ) result = result * val;
  return result;
}
	    
void help()
{

  printf("\n\tNiceshaper version:%s\n", version);
  printf("\thttp://niceshaper.jedwabny.net\n");
  printf("\tPlease usage: niceshaper {start|stop|restart|convert|stats}\n\n");
  printf("\tto overwrite defaults config files locations:\n");
  printf("\t--conffile {path/file}\n");
  printf("\t--classfile {path/file}\n");
  printf("\t--usersfile {path/file} ( for convert mode )\n\n");
  printf("\tto overwrite config dir only:\n");
  printf("\t--workdir {path}\n\n");
}
