#ifndef NS_CLASS_H
#define NS_CLASS_H

#include "niceshaper.h"
#include "ns_filter.h"

class classattrib {
public:
  classattrib();
  ~classattrib();
  friend class nsattrib;    
  int store(char[]);
  int prepare_tcclass(unsigned int);
  int sysinit_iptables();
  unsigned int check(std::vector < char * > &, struct timeval, float);
  int add();
  int del();
  int change();
  void stats(int);
  unsigned int turn_back_usage_percent();
  unsigned int turn_back_rate();
  unsigned int turn_back_htb_ceil() { return htb_ceil; } 
  unsigned int expect_h5n1_rate( unsigned int );
private:
  char dev[MAX_IFACE];
  char name[20];
  char tcclass_add[LONG_BUF];
  char tcqdisc_add[LONG_BUF];
  char tcclass_del[LONG_BUF];
  char tcqdisc_del[LONG_BUF];
  unsigned int classid;
  unsigned long int bytes;
  unsigned long int alive;
  unsigned int htb_prio;
  unsigned int hold;
  unsigned int usage_percent;
  unsigned int local_section_id;
  unsigned int htb_rate;
  unsigned int htb_ceil;
  unsigned int old_htb_rate;  
  unsigned int old_htb_ceil;
  unsigned int rate;
  unsigned int low;
  unsigned int ceil;
  float permill_bits;  
  float relative_using;
  bool class_interactive;
  bool use_ipt;  
  bool use_tc_class;
  bool use_tc_filter;
  bool sum_in_section;
  bool stats_show_htb_ceil;
  bool stats_show_rate;
  bool work;      
  filtertype filter;
  qdisctype qdisc;
  std::vector < filterattrib * >tcfilter;  
};

#endif
