#include "ns_container.h"

nsattrib::nsattrib()
{
  reload = 50;
}

int nsattrib::init()
{
  unsigned int low = 0;
  unsigned int ceil = 0;
  unsigned int htb_prio = 5;
  unsigned int hold = 30;
  unsigned int section_classes = 0;
  unsigned int classid = 1001;
  unsigned int filterid = 1;
  char classtype[12] = "";
  char scheduler[12] = "sfq";
  char buf[LONG_BUF], buf2[LONG_BUF], buf3[LONG_BUF], option[SHORT_BUF];
  char dev_[MAX_IFACE], dev__[MAX_IFACE];
  bool alias;
  bool mydatablock;
  bool imq_auto_redirect = false;
  bool ipt_return = false;
  char section_set[SHORT_BUF];
  char section_end[SHORT_BUF];
  FILE *fp;

  sprintf(section_set, "<%s>", section);
  sprintf(section_end, "</%s>", section);

  vector < char * > fpv_cf; 
  vector < char * > fpv_cl; 
  vector < char * >::iterator fpv_i, fpv_begin_i, fpv_end_i, fpv_tmp_i; 

  fp = fopen(conffile, "r");
  fseek(fp, 0, SEEK_SET);
  if ( conv_to_fpv ( fpv_cf, fp , NULL ) == -1 ) {
	fclose(fp);
	return -1;
  }	
  fclose(fp);  
  
  
  fpv_section_i(fpv_begin_i, fpv_end_i, fpv_cf, section);

  fpv_i = fpv_begin_i;  
  while ( fpv_i != fpv_end_i ) {
	strcpy ( buf , *fpv_i );
	fpv_i++;
    strcpy(option, awk(buf, 1));
    if (!strcmp(option, "section")) {
      if (strstr(buf, "speed"))	section_htb_ceil = unitconvert(awk(strstr(buf, "speed"), 2), bit);
      if (strstr(buf, "shape"))	section_shape = unitconvert(awk(strstr(buf, "shape"), 2), bit);
    } 
    else if (!strcmp(option, "default")) {
      int i=2;
      char option2[SHORT_BUF];
      while (strlen (awk(buf, i) ) ) {
        strcpy(option2, awk(buf, i));
  		if (!strcmp(option2, "low")) { i++; low = unitconvert(awk(buf, i), bit); }
		else if (!strcmp(option2, "ceil")) { i++; ceil = unitconvert(awk(buf, i), bit); }
		else if (!strcmp(option2, "rate")) { i++; low = ceil = unitconvert(awk(buf, i), bit); }
		else if (!strcmp(option2, "overtake")) { i++; }
		else if (!strcmp(option2, "htb-prio")) { i++; htb_prio = atoi(awk(buf, i)); }
		else if (!strcmp(option2, "htb-scheduler")) { i++; strcpy(scheduler, awk(buf, i)); }
		else if (!strcmp(option2, "hold")) { i++; hold = atoi(awk(buf, i)); }
		else if (!strcmp(option2, "imq-redirect")) imq_auto_redirect = true;
		else if (!strcmp(option2, "iptables-return")) ipt_return = true;
        else if (!strcmp(option2, "do-not-shape")) strcpy(classtype, "do-not-shape");
        else if (!strcmp(option2, "virtual")) strcpy(classtype, "virtual");
        else if (!strcmp(option2, "wrapper")) strcpy(classtype, "wrapper");
    	else {
          printf("\t%s: unrecognized option: %s\n", section, buf);
          fclose(fp);
          return -1;
		}  
        i++;
      }
    }
    else if (!strcmp(option, "reload")) {  
      if ( !strcmp(awk(buf, 2), "false")) {
        reload = 0;
      }
      else {
        reload = (unsigned int)(strtof(awk(buf, 2), NULL)*10);
        if (( reload == 0 ) || ( reload > 6000 ))
	{
          printf("\t%s: Wrong reload. Must be in range: (0.1s - 600s): %s\n", section, buf);	
          fclose(fp);
          return -1;
	}
      }
    }
    else if (!strcmp(option, "mode")) {
      if (!strcmp(awk(buf, 2), "download")) {
		strcpy(ipt_myparent, "POSTROUTING");
      }
      if (!strcmp(awk(buf, 2), "upload")) {
		strcpy(ipt_myparent, "PREROUTING");
      }
    } 
    else if (!strcmp(option, "debug")) {
      if (strstr(buf, "iptables")) debug_ipt = true;
      if (strstr(buf, "iproute")) debug_tc = true;
    } 
    else if (!strcmp(option, "iface")) {
	  fpv_tmp_i = fpv_i;
      strcpy(dev_, awk(*fpv_i, 2));
	  fpv_i = fpv_begin_i;
      alias = false;
	  while ( fpv_i != fpv_tmp_i ) { 	  
		strcpy ( buf , *fpv_i );		
		fpv_i++;
		strcpy ( option, awk(buf, 1));
		if (!strcmp(option, "iface") && (fpv_i != fpv_tmp_i)) {
		  strcpy(dev__, awk(buf, 2));
	  	  if (!strcmp(dev_, dev__)) alias = true;
		}
      }
	  fpv_i = fpv_tmp_i;
      strcpy(buf2, buf);
      net.push_back(new netattrib());
      if (net[net.size() - 1]->init(buf2, alias) == -1)	return -1;
      alias = false;
    } 
    else if (!strcmp(option, "<global>") || !strcmp(option, "</global>")) continue;
    else if (!strcmp(option, section_set) || !strcmp(option, section_end)) continue;
    else {
      printf("\t%s: unrecognized option: %s\n", section, buf);
      return -1;
    }
  }
  
  fp = fopen(classfile, "r");
  fseek(fp, 0, SEEK_SET);
  if ( conv_to_fpv ( fpv_cl, fp , NULL ) == -1 ) {
	fclose(fp);
	return -1;
  }	
  fclose(fp);  
  
  mydatablock = false;
  fpv_i=fpv_cl.begin();
  while ( fpv_i != fpv_cl.end() ) {
	strcpy ( buf , *fpv_i );
	fpv_i++;
    strcpy(option, awk(buf, 1));
    if (!strcmp(option, "class")) {
      if (!strcmp(awk(buf, 2), section)) {
	section_classes++;
	mydatablock = true;
	tcclass.push_back(new classattrib);
	fpv_tmp_i = fpv_i;
	while ( fpv_i != fpv_cl.end() ) {
	  strcpy ( buf2 , *fpv_i );
	  fpv_i++;
	  strcpy(option, awk(buf2, 1));
	  if (!strcmp(option, "class")) break;
	  if (!strcmp(option, "match")) {
	    if (tcclass[(tcclass.size() - 1)]->store(buf2) == -1) { return -1; }
	    sprintf(buf3, "filterid %d", filterid);
	    if (tcclass[(tcclass.size() - 1)]->store(buf3) == -1) { return -1; }
	    filterid++;
	  }
	}
	fpv_i=fpv_tmp_i;
	sprintf(buf2, "low %d", low);
	tcclass[tcclass.size() - 1]->store(buf2);
	sprintf(buf2, "ceil %d", ceil);
	tcclass[tcclass.size() - 1]->store(buf2);
	sprintf(buf2, "htb-prio %d", htb_prio);
	tcclass[tcclass.size() - 1]->store(buf2);
	sprintf(buf2, "htb-scheduler %s", scheduler);
	tcclass[tcclass.size() - 1]->store(buf2);
	sprintf(buf2, "hold %d", hold);
	tcclass[tcclass.size() - 1]->store(buf2);
	sprintf(buf2, "classid %d", classid);
	tcclass[tcclass.size() - 1]->store(buf2);
	if (imq_auto_redirect) tcclass[tcclass.size() - 1]->store("imq-redirect");	
	if (ipt_return ) tcclass[tcclass.size() - 1]->store("iptables-return");	
	tcclass[tcclass.size() - 1]->store(classtype);	
      } 
      else {
	mydatablock = false;
      }
      classid++;
    }
    if (mydatablock && strcmp(awk(buf, 1), "match")) {
      if (tcclass[tcclass.size() - 1]->store(buf) == -1) {
	return -1;
      }
    }
    else if ( !mydatablock && !strcmp(awk(buf, 1), "match")) {
      filterid++;
    }
  }

  for (unsigned int i = 0; i < tcclass.size(); i++) {
    if ( tcclass[i]->prepare_tcclass(section_classes) == -1 ) return -1;
  }

  gettimeofday(&ltt, NULL);
  sprintf(buf, "iptables -t mangle -N %s", ipt_mychain);
  system_ipt(buf);
  for (unsigned int i = 0; i < tcclass.size(); i++) {
    if (tcclass[i]->sysinit_iptables() == -1) return -1;
  }
  for (unsigned int i = 0; i < net.size(); i++) { 
    if (net[i]->envinit() == -1) return -1; 
  }
  return 0;
}

nsattrib::~nsattrib()
{
  char buf[LONG_BUF];

  for (unsigned int n = 0; n < net.size(); n++) delete net[n];
  net.clear();

  for (unsigned int n = 0; n < tcclass.size(); n++) delete tcclass[n];
  tcclass.clear();

  sprintf(buf, "iptables -t mangle -F %s 2> /dev/null > /dev/null", ipt_mychain);
  system_ipt(buf);
  sprintf(buf, "iptables -t mangle -X %s 2> /dev/null > /dev/null", ipt_mychain);
  system_ipt(buf);
}

void nsattrib::judge ()
{
  unsigned int old_section_rate = 0;
  unsigned int section_rate = 0;
  unsigned int section_rate_without_permill_bits = 0;
  unsigned int tcclass_rate = 0;
  int overload; 
  int overload_relative_permill;  
  float relative_permill_bits_sum;
  char buf[LONG_BUF];
  struct timeval now;
  float cycle_time;
  float relative_using_sum;
  FILE *fp;  
  vector < char * > iptables_summary;  
  vector < classattrib * > working_tcclass;  

  gettimeofday(&now, NULL);
  cycle_time =  (float) (1000000 * (now.tv_sec - ltt.tv_sec) + now.tv_usec - ltt.tv_usec) / 1000000;
  gettimeofday(&ltt, NULL);
  sprintf(buf, "iptables -t mangle -L -Z %s -vnx", ipt_mychain);
  fp = popen(buf, "r");
  fgets(buf, LONG_BUF, fp);
  fgets(buf, LONG_BUF, fp);
  char * buf_ptr;  
  while ( fgets(buf, LONG_BUF, fp) ) {
	buf_ptr = new char[LONG_BUF];
	strcpy ( buf_ptr , buf );
	iptables_summary.push_back(buf_ptr);  
  }
  pclose(fp);
  
  delete iptables_summary[iptables_summary.size()-1];     
  iptables_summary.pop_back();    

  unsigned int cycle_counter = 0;
  do {
    if ( !cycle_counter ) {
	  for ( unsigned int i = 0; i < tcclass.size(); i++ ) {
		tcclass_rate = tcclass[i]->check( iptables_summary, now, cycle_time );
		if ( tcclass_rate ) {	
		  if ( tcclass[i]->permill_bits ) 
			working_tcclass.push_back(tcclass[i]);
		  else 
			section_rate_without_permill_bits += tcclass_rate;
  		  section_rate += tcclass_rate;		
		}
	  }
	}
	else {
	  old_section_rate=section_rate;
	  section_rate = section_rate_without_permill_bits;
	  for ( unsigned int i = 0; i < working_tcclass.size(); i++ ) {
	    if ( working_tcclass[i]->rate < working_tcclass[i]->htb_ceil ) 
		  section_rate += working_tcclass[i]->rate;	  
	    else 
		  section_rate += working_tcclass[i]->htb_ceil;	  
	  }
	}

	if ( !working_tcclass.size() ) break;

    if ( section_rate > section_htb_ceil ) 
	  section_rate=section_htb_ceil;		

	relative_using_sum = 0;
	relative_permill_bits_sum = 0;
	for ( unsigned int i = 0; i < working_tcclass.size(); i++ ) {	
	  if ( working_tcclass[i]->rate < working_tcclass[i]->low ) continue;
		working_tcclass[i]->relative_using=(float)(working_tcclass[i]->rate-working_tcclass[i]->low)/(float)(working_tcclass[i]->ceil-working_tcclass[i]->low); //<0-1> czesc swojego ceil-low
		relative_using_sum += working_tcclass[i]->relative_using;
		relative_permill_bits_sum += working_tcclass[i]->permill_bits*working_tcclass[i]->relative_using;
	}

	overload = section_rate - section_shape;	
	overload_relative_permill = (int)(overload/relative_permill_bits_sum);
	for ( unsigned int i = 0; i < working_tcclass.size(); i++ ) {	
	  if ( working_tcclass[i]->rate > working_tcclass[i]->low ) {
		if ( overload >= 0 )
	  	  working_tcclass[i]->htb_ceil -= (int)(overload_relative_permill*working_tcclass[i]->permill_bits*working_tcclass[i]->relative_using);
		else 
		  working_tcclass[i]->htb_ceil -= (int)(overload_relative_permill*working_tcclass[i]->permill_bits*(relative_using_sum-working_tcclass[i]->relative_using));
	  }
	  else {
		if ( section_rate > section_shape ) 
		  working_tcclass[i]->htb_ceil += (unsigned int)working_tcclass[i]->permill_bits*5;
		else 
		  working_tcclass[i]->htb_ceil += (unsigned int)working_tcclass[i]->permill_bits*20;		
	  }	
	}	  
	
	section_rate=section_rate_without_permill_bits;
	for ( unsigned int i = 0; i < working_tcclass.size(); i++ ) {
		if ( working_tcclass[i]->htb_ceil > working_tcclass[i]->low+working_tcclass[i]->permill_bits*section_max_permills ) 
		  working_tcclass[i]->htb_ceil = working_tcclass[i]->low+(unsigned int)(section_max_permills*working_tcclass[i]->permill_bits);
		if ( working_tcclass[i]->htb_ceil > working_tcclass[i]->ceil ) 
		  working_tcclass[i]->htb_ceil = working_tcclass[i]->ceil;
		if ( working_tcclass[i]->htb_ceil < working_tcclass[i]->low )
		  working_tcclass[i]->htb_ceil = working_tcclass[i]->low;

  		if ( working_tcclass[i]->rate < working_tcclass[i]->htb_ceil )
		  section_rate += working_tcclass[i]->rate;
		else
		  section_rate += working_tcclass[i]->htb_ceil;
	}
	cycle_counter++;
	
  } while (( section_rate > section_shape ) && ( section_rate != old_section_rate ));
  
  for (unsigned int i = 0; i < tcclass.size(); i++) 
	tcclass[i]->change();
	
}

void nsattrib::stats(int pipe_write)
{
  char buf[LONG_BUF];

  sprintf(buf, "%s rate utilize\n", section);
  write(pipe_write, buf, strlen(buf));
  for (unsigned int i = 0; i < tcclass.size(); i++) {
    tcclass[i]->stats(pipe_write);
  }
}

